#include <iostream>
#include <vector>
#include <stack>
#include <climits>
#include <algorithm>

using namespace std;

struct point {
	int x, y;
	
	point(int _x = 0, int _y = 0) {
		x = _x;
		y = _y;
	}
	
	bool operator< (point b) {
		if(x == b.x)
			return y < b.y;
		return x < b.x;
	}
	
	int dist(point b) {
		return max( abs(b.x - x), abs(b.y - y) );
	}
};

point zero = point(0,0);

bool srt(point a, point b) {
	return zero.dist(a) < zero.dist(b);
}

struct pth {
	int pos;
	int num, dist;
	
	pth(int _pos, int _num, int _dist) {
		pos = _pos;
		num = _num;
		dist = _dist;
	}
};

int main() {
	int n;
	
	cin>>n;
	
	vector<point> points;
	points.push_back(zero);
	
	for(int i=0; i<n; i++) {
		point a;
		
		cin >> a.x >> a.y;
		points.push_back(a);

		cin >> a.x >> a.y;
		points.push_back(a);
	}
	
	sort(points.begin(), points.end(), srt);
	
	stack< pth > path;
	
	path.push( pth(0, 0, 0) );
	
	int curr_min = INT_MAX;
	
	bool first = true;
	
	while(path.size() > 1 || first) {
		first = false;
		pth curr = path.top();
		
		for(int i=curr.pos+1; i<points.size(); i++) {
			if( points.size() - i >= n - curr.num) {
				int new_dist = curr.dist + points[i].dist(points[curr.pos]);
				
				if(curr.num == n-1) {
					curr_min = min(curr_min, new_dist);
				} else
					path.push(pth( i, curr.num+1, new_dist ));
			}
		}
		
		if(curr.num == n-1) {
			path.pop();
		}
	}
	
	cout<<curr_min<<endl;
	
	return 0;
}

