#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 10010;

int n, a[N];

struct BE
{
	int l, r;

	BE() {}

	BE(int _l, int _r)
	{
		l = _l;
		r = _r;
	}

	void Print() const
	{
		printf("%d %d\n", l, r);
	}
};

void Input()
{
	scanf("%d", &n);

	for (int i = 1; i <= n; i++)
		scanf("%d", &a[i]);
}

BE FindPal1(int l, int r)
{
	int p = l, q;
	
	while (a[r] != -1 && a[l] != a[r]) r--;
	q = r;

	//printf("end: %d\n", r);

	while (r >= l && a[l] == a[r])
	{
		l++; r--;
		if (a[l] != a[r]) return BE(-1, -1);
	}

	//printf("%d %d\n", l, r);
	return BE(p, r);
}

BE FindPal2(int l, int r)
{
	int p, q = r;
	
	while (a[l] != -1 && a[l] != a[r]) l++;
	p = l;

	//printf("beg: %d\n", l);

	while (l <= r && a[l] == a[r])
	{
		l++; r--;
		if (a[l] != a[r]) return BE(-1, -1);
	}

	//printf("%d %d\n", l, r);

	return BE(p, q);
}

void Solve()
{
	vector <int> res;
	
	int i, l = 1, r = n, len1, len2;
	BE p, q;
	
	a[0] = -1;
	a[n + 1] = -1;

	while (l <= r)
	{
		p = FindPal1(l, r);
		q = FindPal2(l, r);

		//p.Print();
		//q.Print();

		len1 = fabs(p.l - p.r);
		len2 = fabs(q.l - q.r);

		if (len1 > len2)
		{
			l = p.r + 1;
			res.push_back(l);
		}
			else if (len2 > len1)
			{
				r = q.l - 1;
				res.push_back(r);
			}
		//printf("%d %d\n\n", l, r);
	}
	res.pop_back();
	sort(res.begin(), res.end());

	if (res[0] == 0)
	{
		printf("1\n");
		return;
	}
	
	printf("%d\n", res.size() + 1);

	printf("%d", res[0]);
	for (i = 1; i < res.size(); i++)
		printf(" %d", res[i]);

	printf("\n");
}

int main()
{
	Input();
	Solve();
	
	return 0;
}