#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <utility>
using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;

string str;
map<string, pll> mem;

inline int isSign(char ch)
{
	if (ch == '-') return 1;
	if (ch == '+') return 2;
	if (ch == '*') return 3;
	return 0;
}

inline ll move(ll a, ll b, int op)
{
	if (op == 1) return a-b;
	if (op == 2) return a+b;
	if (op == 3) return a*b;
}

inline void update(pll &ref, const pll a, const pll b, int op)
{
	//cout << "update " << a.first << ' ' << a.second << ' ' << b.first << ' ' << b.second << " and operation = " << op << endl;
	ref.first = min(ref.first, move(a.first, b.first, op));
	ref.first = min(ref.first, move(a.first, b.second, op));
	ref.first = min(ref.first, move(a.second, b.first, op));
	ref.first = min(ref.first, move(a.second, b.second, op));
	ref.second = max(ref.second, move(a.first, b.first, op));
	ref.second = max(ref.second, move(a.first, b.second, op));
	ref.second = max(ref.second, move(a.second, b.first, op));
	ref.second = max(ref.second, move(a.second, b.second, op));
	//cout << "reference is updated: " << ref.first << ' ' << ref.second << endl;
}

pll solve(string cur)
{
	//cout << "in solve |" << cur << "|" << endl;
	if (cur.size() == 1) return pll(cur[0]-'0', cur[0]-'0');
	if (mem.find(cur) != mem.end()) return mem[cur];
	
	pll &ref = mem[cur];
	int now, first = 1;
	for (int i=0; i < cur.size(); ++i)
		if (now = isSign(cur[i]))
		{
			pll l = solve(cur.substr(0,i)),
				r = solve(cur.substr(i+1));
			//cout << "left part " << l.first << ' ' << l.second << " and right one " << r.first << ' ' << r.second << endl;
			if (first) ref.first = ref.second = move(l.first, r.first, now), first = 0;
			update(ref, l, r, now);
		}
	//cout << "returning for |" << cur << "| ->> " << ref.first << ' ' << ref.second << endl;
	return ref;
}

inline void read()
{
	cin >> str;
}

int main()
{
	read();
	cout << solve(str).first << endl;
	return 0;
}
