/*
PROB: express
LANG: C++
*/
#include <iostream>
#include <numeric>
#include <cstdio>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#define eprintf( msg , ... ) 0 //fprintf( stderr , "Line %d in %s => " msg "\xA" , __LINE__ , __FUNCTION__ , ##__VA_ARGS__ );

using std::min;
using std::max;
using std::cout;
using std::endl;

typedef long long ll;

const int MAXN = 1 << 6;
const ll INF = 1000LL * 1000LL * 1000LL * 1000LL * 1000LL * 100LL + 1;

int N;
char msg[MAXN];
int a[MAXN];
char calcmin[MAXN][MAXN];
char calcmax[MAXN][MAXN];
char calczero[MAXN][MAXN];
char calcless[MAXN][MAXN];

ll dpmin[MAXN][MAXN];
ll dpmax[MAXN][MAXN];
ll dpzero[MAXN][MAXN];
ll dpless[MAXN][MAXN];

ll getmin( int , int );
ll getmax( int , int );
ll getzero( int , int );
ll getless( int , int );

void rezero( ll &self , ll newval ){
    if( newval >= 0 and self > newval )
        self = min( self , newval );
}
void remax( ll &self , ll newval ){
    self = max( self , newval );
}
void remin( ll &self , ll newval ){
    self = min( self , newval );
}
void reless( ll &self , ll newval ){
    if( newval <= 0 and self < newval )
        self = max( self , newval );
}

ll getmin( int left , int right ){
    if( left == right ){
        //eprintf("Min( %d , %d ) = %lld", left, right, (ll)a[left/2]);
        return (ll) a[left/2];
    }
    
    ll &self = dpmin[left][right];
    
    if( calcmin[left][right] )
        return self;
    
    calcmin[left][right] = 1;
    self = INF;
    
    for( int i = left ; i <= right ; i++ ){
        if( i & 1 ){
            ll onleft[] = { getmin( left , i - 1 ) , getmax( left , i - 1 ) , getzero( left , i - 1 ) , getless( left , i - 1 ) };
            ll onright[] = { getmin( i + 1 , right ) , getmax( i + 1 , right ) , getzero( i + 1 , right ) , getless( i + 1 , right ) };
            if( msg[i] == '-' ){ /// to minimize it we must get the min from the left and the max from the right
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        remin( self , onleft[i] - onright[j] );
                    }
            }else if( msg[i] == '+' ){ /// to minimize it we must get the two mins
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        remin( self , onleft[i] + onright[j] );
                    }
            }else if( msg[i] == '*' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        remin( self , onleft[i] * onright[j] );
                    }
            }
        }
    }
    
    eprintf("Min( %d , %d ) = %lld", left , right , self );
    
    return self;
}
ll getmax( int left , int right ){
    if( left == right ){
        //eprintf("Max( %d , %d ) = %lld", left , right , (ll)a[left/2]);
        return a[left/2];
    }
    
    ll &self = dpzero[left][right];
    
    if( calcmax[left][right] )
        return self;
    
    calcmax[left][right] = 1;
    self = -INF;
    
    for( int i = left ; i <= right ; i++ ){
        if( i & 1 ){
            ll onleft[] = { getmin( left , i - 1 ) , getmax( left , i - 1 ) , getzero( left , i - 1 ) , getless( left , i - 1 ) };
            ll onright[] = { getmin( i + 1 , right ) , getmax( i + 1 , right ) , getzero( i + 1 , right ) , getless( i + 1 , right ) };
            if( msg[i] == '-' ){/// to get the max we must get the max from the left and the min from right
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        remax( self , onleft[i] - onright[j] );
                    }
            }else if( msg[i] == '+' ){/// to get the max we must get the two maxes
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        remax( self , onleft[i] + onright[j] );
                    }
            }else if( msg[i] == '*' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        remax( self , onleft[i] * onright[j] );
                    }
            }
        }
    }
    
    eprintf("Max( %d , %d ) = %lld", left , right , self );
    
    return self;
}
ll getzero( int left , int right ){
    if( left == right ){
        //eprintf("Zero( %d , %d ) = %lld\n", left, right, ( a[left/2] >= 0 ? a[left/2] : INF ) );
        if( a[left/2] >= 0 ) return a[left/2];
        else return INF;
    }
    ll &self = dpzero[left][right];
    
    if( calczero[left][right] )
        return self;
    
    calczero[left][right] = 1;
    self = INF;
    
    for( int i = left ; i <= right ; i++ ){
        if( i & 1 ){
            ll onleft[] = { getmin( left , i - 1 ) , getmax( left , i - 1 ) , getzero( left , i - 1 ) , getless( left , i - 1 ) };
            ll onright[] = { getmin( i + 1 , right ) , getmax( i + 1 , right ) , getzero( i + 1 , right ) , getless( i + 1 , right ) };
            if( msg[i] == '+' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        rezero( self , onleft[i] + onright[j] );
                    }
            }else if( msg[i] == '-' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        rezero( self , onleft[i] - onright[j] );
                    }
            }else if( msg[i] == '*' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        rezero( self , onleft[i] * onright[j] );
                    }
            }
        }
    }
    
    eprintf("Zero( %d , %d ) = %lld", left , right, self);
    
    return self;
}
ll getless( int left , int right ){
    if( left == right ){
        if( a[left/2] <= 0 ) return a[left/2];
        else return -INF;
    }
    ll &self = dpless[left][right];
    
    if( calcless[left][right] )
        return self;
    
    calcless[left][right] = 1;
    self = -INF;
    
    for( int i = left ; i <= right ; i++ ){
        if( i & 1 ){
            ll onleft[] = { getmin( left , i - 1 ) , getmax( left , i - 1 ) , getzero( left , i - 1 ) , getless( left , i - 1 ) };
            ll onright[] = { getmin( i + 1 , right ) , getmax( i + 1 , right ) , getzero( i + 1 , right ) , getless( i + 1 , right ) };
            if( msg[i] == '+' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        reless( self , onleft[i] + onright[j] );
                    }
            }else if( msg[i] == '-' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        reless( self , onleft[i] - onright[j] );
                    }
            }else if( msg[i] == '*' ){
                for( int i = 0 ; i < 4 ; i++ )
                    for( int j = 0 ; j < 4 ; j++ ){
                        if( onleft[i] == INF or onleft[i] == -INF ) continue;/// no closest to zero
                        if( onright[j] == INF or onright[j] == -INF ) continue;/// no closest to zero
                        reless( self , onleft[i] * onright[j] );
                    }
            }
        }
    }
    
    eprintf("Less( %d , %d ) = %lld", left,right,self);
    
    return self;
}

int main(){
	//freopen( "express.in" , "r" , stdin );
	//freopen( "express.out" , "w" , stdout );
	//freopen( "express.err" , "w" , stderr );
	
	scanf("%s", msg);
	N = strlen( msg );
	
	for( int i = 0 ; i < N ; i+= 2 ){
        a[i/2] = msg[i] - '0';
        eprintf("A[%d] = %d", i/2, a[i/2]);
    }
    
	cout << getmin( 0 , N-1 ) << endl;
	
	return 0;
}
