/*
PROB: frog
LANG: C++
*/
#include <iostream>
#include <numeric>
#include <cstdio>
#include <vector>
#include <cmath>
#include <cstring>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <ctime>
#include <algorithm>
#define eprintf( msg , ... ) 0; //fprintf( stderr , "Line %d in %s => " msg "\xA" , __LINE__ , __FUNCTION__ , ##__VA_ARGS__ );

typedef long long ll;

using namespace std;

const int MAXN = ( 1 << 4 );
const int MAXR = 1 << 12;
const int INF = 1 << 30;

const int dx[] = {1,1,-1,-1};
const int dy[] = {1,-1,1,-1};

int N;
//int used[MAXR][MAXR];
int X[MAXN], Y[MAXN];
int dp[ 1 << MAXN ];

inline int nice( int x , int y ){
    return x >= -2000 and y >= -2000 and x <= 2000 and y <= 2000;
}
inline int toIndex( int x ){
    return x + 2000;
}
inline int dist( int dx , int dy ){
    if( dx > dy )
        return dist( dy , dx );
    if( ( dy - dx ) % 2 == 1 ) return -1;
    else return max( abs( dx ) , abs( dy ) );
}
/*
void bfs(){
    memset( used , -1 , sizeof( used ) );
    
    queue< pair<int,int> > q;
    q.push( make_pair( 0 , 0 ) );
    used[ toIndex(0) ][ toIndex(0) ] = 0;
    
    int level = 1;
    
    while( !q.empty() ){
        int size = q.size();
        for( int el = 0 ; el < size ; el++ ){
            pair<int,int> at = q.front();
            q.pop();
            
            for( int j = 0 ; j < 4 ; j++ ){
                int x = at.first + dx[j];
                int y = at.second + dy[j];
                if( nice( x , y ) and used[ toIndex(x) ][ toIndex(y) ] == -1 ){
                    used[ toIndex(x) ][ toIndex(y) ] = level;
                    q.push( make_pair( x , y ) );
                }
            }
        }
        level++;
    }
}
*/
int get( int state ){
    if( __builtin_popcount( state ) == N/2 + 1 ){
        return 0;
    }
    
    int &self = dp[state];
    
    if( self != -1 )
        return self;
    
    self = INF;
    
    for( int i = 0 ; i <= N ; i++ ){
        if( ( state & ( 1 << i ) ) == 0 ) continue;
        for( int j = 0 ; j <= N ; j++ ){
            if( ( state & ( 1 << j ) ) != 0 ) continue;
            if( dist( X[j] - X[i] , Y[j] - Y[i] ) == -1 ) continue;
            self = min( self , get( state | ( 1 << j ) ) + dist( X[j] - X[i] , Y[j] - Y[i] ) );
        }
    }
    
    //printf("dp[%d] = %d\n", state, self );
    
    return self;
}

int main(){
	//freopen( "frog.in" , "r" , stdin );
	//freopen( "frog.out" , "w" , stdout );
	
	scanf("%d", &N);
	N = N * 2;
	
	X[0] = 0, Y[0] = 0;
	
	for( int i = 1 ; i <= N ; i++ ){
        scanf("%d %d", &X[i], &Y[i]);
	}
	/*
	bfs();
	for( int i = -2000 ; i <= 2000 ; i++ ){
        for( int j = -2000 ; j <= 2000 ; j++ )
            if ( used[ toIndex(i) ][ toIndex(j) ] != dist( i , j ) ){
                eprintf("Hey %d %d %d %d", i,j, used[ toIndex(i) ][ toIndex(j) ], dist(i,j) ); return 0;
            }
    }
	*/
	memset( dp , -1 , sizeof( dp ) );
	
	printf("%d\n", get( 1 ) );
	
	fprintf( stderr , "Time: %.2lf\n", clock() / (double) CLOCKS_PER_SEC );
	return 0;
}
