/*
PROB: pircos
LANG: C++
*/
#include <cstdio>
#include <algorithm>
#include <vector>
#include <ext/hash_map>
#include <set>
#define eprintf( msg , ... ) 0;//fprintf( stderr , "Line %d in %s => " msg "\xA" , __LINE__ , __FUNCTION__ , ##__VA_ARGS__ );

typedef unsigned long long ll;

using namespace std;
using namespace __gnu_cxx;

const int MAX = 60000;/// ~480KB
const int UMAPSIZE = 1 << 17;
const int UMAX = 30000;

int N;
/// 512 KB = 64,000 ll

struct hashll{
    inline size_t operator()( const ll &x ) const{
        return (size_t) x;
    }
};
struct cmpll{
    inline bool operator()( const ll &x , const ll &y ) const{
        return x == y;
    }
};
inline void use( unsigned char *used , int which ){
    eprintf("Using index #%d ( Byte %d , 2^%d )", which, which >> 3 , which & 7);
    used[ which >> 3 ] |= ( 1 << ( which & 7 ) );
}
inline int isused( unsigned char *used , int which ){
    return ( used[ which >> 3 ] & ( 1 << ( which & 7 ) ) ) > 0;
}

void solveSort(){
    ll *all = new ll[MAX+1];
    
    for( int i = 0 ; i < N ; i++ ) scanf("%lld", &all[i]);
    std::sort( all , all + N );
    
    all[N] = -1;
    
    vector<int> sol;
    int last = all[0];
    int tmp = 1;
    for( int i = 1 ; i <= N ; i++ ){
        if( last != all[i] ){
            /// end of consecutive blah blah
            if( tmp == 1 ) sol.push_back( last );
            tmp = 1;/// start a new sequence from here
        }else{
            tmp++;
        }
        last = all[i];
    }
    printf("%lld %lld\n", sol[0], sol[1]);
}

void solveManyReads(){
    unsigned char *used = new unsigned char[UMAPSIZE];
    hash_map< ll , int , hashll , cmpll > hs;
    
    for( int i = 0 ; i < UMAPSIZE ; i++ ) used[i] = 0;
    
    int limit = N-2;
    
    int usedcnt = 0;
    
    while( usedcnt != limit ){
        fseek( stdin , 0 , SEEK_SET );
        scanf("%d", &N);
        if( hs.empty() == false ) hs.clear();
        int hssize = 0;
        for( int i = 0 ; i < N ; i++ ){
            ll tmp;
            scanf("%lld", &tmp);
            eprintf("Got %lld", tmp);
            if( isused( used , i ) ){
                //eprintf("Already used %d (%d/%d)", i, usedcnt,limit);
            }else{
                //if( hs.count( Prev( tmp , 0 ) ) > 0 ) /// got that element already at some position
                if( hs.count( tmp ) ){ /// got that element
                    use( used , hs[tmp] );
                    use( used , i );
                    hs.erase( tmp );
                    hssize--;
                    usedcnt+=2;
                    eprintf("Found 2 x %lld( using %d %d )", tmp, hs[tmp], i);
                }else if( hssize < UMAX ){
                    eprintf("Using %lld at %d", tmp, i);
                    hs[tmp] = i;
                    hssize++;
                }
            }
        }
    }
    ll sol[2];
    int at=0;
    
    fseek( stdin , 0 , SEEK_SET );
    scanf("%d", &N);
    for( int i = 0 ; i < N ; i++ ){
        ll tmp;
        scanf("%lld", &tmp);
        if( !isused( used , i ) ){
            //printf("%lld ", tmp);
            sol[at++] = tmp;
        }
    }
    if( sol[0] > sol[1] ) swap( sol[0] , sol[1] );
    
    printf("%lld %lld\n", sol[0], sol[1]);
}

int main(){
	//freopen( "pircos.in" , "r" , stdin );
	//freopen( "pircos.out" , "w" , stdout );
	
	scanf("%d", &N);
	
	if( N <= -MAX ) solveSort();
	else solveManyReads();
	
	/*
	fseek( stdin , 0 , 0 );
	
	scanf("%d", &N);
	
	for( int i = 0 ; i < N ; i++ ){
        ll tmp;
        scanf("%lld", &tmp);
        printf("%lld\n", tmp);
        printf("Allxor is %lld\n", allxor ^= tmp );
	}
    */
    
    fprintf( stderr , "Time: %.2lf", clock() / (double) CLOCKS_PER_SEC );
	return 0;
}
