#include <iostream>
#include <queue>
#include <stdio.h>
#include <algorithm>
#include <cstring>

#define m 1000
#define inf 1 << 30

using namespace std;

int N;

int dist[16][16];

struct points {
    int x, y;

    points (int _x, int _y): x(_x), y(_y) {}
    points () {}
} p[16];

void find_min_dist (int start) {
    for (int i = 0; i <= 2*N; i++)
        dist[start][i] = max (abs (p[start].x - p[i].x), abs (p[start].y - p[i].y));
}

bool is_set (int i, int mask) {
    return !!(mask & (1 << i));
}

int dp[13][1 << 13];

int dfs (int u, int mask) {
    if (__builtin_popcount(mask) == N + 1) return 0;

    int &res = dp[u][mask];

    if (res != -1) return res;

    res = inf;
    for (int i = 0; i <= 2*N; i++)
        if (!is_set (i, mask)) {
            res = min (res, dfs (i, mask ^ (1 << i)) + dist[u][i]);
        }

    return res;
}

int main() {
    memset (dp, -1, sizeof dp);

    scanf ("%d", &N);
    p[0] = points (0, 0);

    for (int i = 1; i <= 2*N; i++)
        scanf ("%d%d", &p[i].x, &p[i].y);

    for (int i = 0; i <= 2*N; i++)
        find_min_dist (i);

    printf ("%d\n", dfs (0, 1));
}
